package compilateur.cspLangage;

import compilateur.CompilationException;

import antlr.Token;

public class CommandePrint extends Commande {

	public ExpressionSimple expr;

	public CommandePrint(ListeCommande parent) {
		this.parent = parent;
	}

	public String compile () throws CompilationException {
		return "/* " + buildCsp() + " */\n" + "print(" + expr.compile() + ");";
	}
	
	private String buildCsp() throws CompilationException {
		return "print (" + expr.buildCsp() + ")";
	}

	@Override
	public void changeVariable(String oldVar, String newVar) {
		expr.changeVariable(oldVar, newVar);
	}

}
