package compilateur.cspLangage;

import compilateur.CompilationException;

public class CommandeSleep extends Commande {

	public ExpressionSimple expr;

	public CommandeSleep(ListeCommande parent) {
		this.parent = parent;
	}

	public String compile () throws CompilationException {
		return "/* " + buildCsp () + " */\n" + "try { Thread.sleep ("+expr.compile()+");} catch (InterruptedException e) { }";
	}
	
	private String buildCsp() throws CompilationException {
		return "sleep (" + expr.buildCsp() + ")";
	}

	@Override
	public void changeVariable(String oldVar, String newVar) {
		expr.changeVariable (oldVar, newVar);
	}
	
}