package compilateur.javaLangage;

import java.util.Vector;

public class Package {

	PackageDeclaration pDeclaration = null;
	Vector<ClassObject> classes = new Vector<ClassObject>(); 
	
	public Package () {
		
	}
	
	public void setName (String name) {
		pDeclaration = new PackageDeclaration (name);
	}
	
	public void generateCode (String dir) {
		
	}
	
	public void addClassObject (ClassObject classObj) throws JavaLangageException {
		if (findClassObject(classObj.getName())!=null)
			throw new JavaLangageException ("Une classe porte dj le nom " + classObj.getName());
		classes.add (classObj);
		classObj.setPackageParent (this);		
	}
	
	public ClassObject findClassObject (String name) {
		for (ClassObject cObj : classes)
			if (cObj.getName().equals(name)) return cObj;
		return null;
	}
}
