package compilateur;

import compilateur.cspLangage.Type;

import util.VarAlreadyExistsException;
import util.VarManager;

public class JavaVarManager extends VarManager<JavaVar, CspVar> {

	public JavaVarManager () {
		super ();
		try {
			addVariable ("package", null);
			addVariable ("import", null);
			addVariable ("public", null);
			addVariable ("private", null);
			addVariable ("protected", null);
			addVariable ("class", null);
			addVariable ("extends", null);
			addVariable ("implements", null);
			addVariable ("super", null);
			addVariable ("try", null);
			addVariable ("catch", null);
			addVariable ("null", null);
			addVariable ("new", null);
			addVariable ("return", null);
			addVariable ("for", null);
			addVariable ("while", null);
			addVariable ("until", null);
			addVariable ("continue", null);
			addVariable ("break", null);
			addVariable ("this", null);
			addVariable ("case", null);
			addVariable ("default", null);
			addVariable ("if", null);
			addVariable ("else", null);
			addVariable ("throw", null);
			addVariable ("throws", null);
			addVariable ("final", null);
			addVariable ("void", null);
			} catch (VarAlreadyExistsException e) {
		}
		
	}
	
	@Override
	protected JavaVar provideVar(String name, Type type, VarManager<JavaVar, CspVar> parent) {
		return new JavaVar (name, type, parent);
	}

}
