package ihm.runtimeIhm;

import static ihm.runtimeIhm.Sync.Mode.*;

public class Sync {

	public static enum Mode {
		RUN, EN_ATTENTE
	}
	
	public Mode mode = EN_ATTENTE; 

	public synchronized void setMode (Mode mode) {
		this.mode = mode;
	}
	
	public synchronized void blockMe () {
		switch (mode) {
		case EN_ATTENTE: 
			try {
				wait ();
			} catch (InterruptedException e) {
			}
			break;
		case RUN :
		default:		
		}
		
	}

	public synchronized void hop () {
		notifyAll ();
	}
}
